﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using Microsoft.Phone.Tasks;
using System.IO;
using System.IO.IsolatedStorage;
using System.Windows.Resources;
using Microsoft.Phone.Shell;


namespace RingtoneDeploy
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        SaveRingtoneTask saveRingtone;

        private void setButton_Click(object sender, RoutedEventArgs e)
        {

            DownloadToIsoStore("Ringtone.wma");

            saveRingtone = new SaveRingtoneTask();
            saveRingtone.Source = new Uri(@"isostore:/Ringtone.wma" );
            saveRingtone.DisplayName = "Ringtone";
            saveRingtone.IsShareable = true;
            saveRingtone.Completed += new EventHandler<TaskEventArgs>(saveRingtone_Completed);
            saveRingtone.Show();
        }

        private void DownloadToIsoStore(string fileName)
        {
            IsolatedStorageFile isoStore = IsolatedStorageFile.GetUserStoreForApplication();

            // If the file already exists, no need to "download", just return
            if (isoStore.FileExists(fileName))
            {
                return;
            }

            StreamResourceInfo sr = Application.GetResourceStream(new Uri(fileName, UriKind.Relative));

            using (BinaryReader br = new BinaryReader(sr.Stream))
            {
                // Simulate "downloading" the ringtone file
                byte[] data = br.ReadBytes((int)sr.Stream.Length);

                // Save to local isolated storage
                SaveToIsoStore(fileName, data);
            }
        }

        private void SaveToIsoStore(string fileName, byte[] data)
        {
            string strBaseDir = string.Empty;
            string delimStr = "/";
            char[] delimiter = delimStr.ToCharArray();
            string[] dirsPath = fileName.Split(delimiter);

            // Get the IsoStore
            IsolatedStorageFile isoStore = IsolatedStorageFile.GetUserStoreForApplication();

            // We want to re-create the directory structure but not the file
            for (int i = 0; i < dirsPath.Length - 1; i++)
            {
                strBaseDir = System.IO.Path.Combine(strBaseDir, dirsPath[i]);

                if (!isoStore.DirectoryExists(strBaseDir))
                {
                    isoStore.CreateDirectory(strBaseDir);
                }
            }

            // Clean out existing file.
            DeleteFromIsoStore(fileName);

            // Write the file 
            using (BinaryWriter bw = new BinaryWriter(isoStore.CreateFile(fileName)))
            {
                bw.Write(data);
                bw.Close();
            }
        }

        /// <summary>
        /// Deletes a file from isolated storage.
        /// </summary>
        /// <param name="fileName"></param>
        private void DeleteFromIsoStore(string fileName)
        {
            // Get the IsoStore
            IsolatedStorageFile isoStore = IsolatedStorageFile.GetUserStoreForApplication();

            // Clean out existing file.
            if (isoStore.FileExists(fileName))
            {
                isoStore.DeleteFile(fileName);
            }
        }

        void saveRingtone_Completed(object sender, TaskEventArgs e)
        {
            if (e.TaskResult != TaskResult.OK) return;

            ShellToast toast = new ShellToast();
            toast.Title = "Ringtone";
            toast.Content = "Tone Deployed";
            toast.Show();          
        }
    }
}